#!/bin/sh
#

# hier is full path to install.img
img=$1 

# hier is path only
path=${img%/*} 

macfile="$path/bootparams.txt"
log="$img.0.bootparam.log"
if [ -e "$macfile" ]; then
	if [ ! -e "$log" ]; then
		touch "$log"
		bcs=31457280
		cat /sys/realtek_boards/system_parameters|grep -q "nand_boot_size=c00000"&&bcs=12582912
		cat /sys/realtek_boards/system_parameters|grep -q "nand_boot_size=3200000"&&bcs=52428800
		echo "MOS: write script address $bcs"
		echo "MOS: write script address $bcs" >> "$log"
		
		ethaddr=""
		ipaddr=""
		gateway=""
		subnetmask=""
		system_parameters_1=""
		system_parameters_2=""
		system_parameters_3=""
		system_parameters_4=""
		Gbit=""

		echo "MOS: read bootparams.txt"
		. "$path/bootparams.txt"
		
		bootcmd=""
		if [ "$ethaddr" != "" ]; then
			echo "MOS: found ethaddr=$ethaddr"
			bootcmd=$bootcmd"setenv ethaddr "$ethaddr";\n"
		fi
		if [ "$ipaddr" != "" ]; then
			echo "MOS: found ipaddr=$ipaddr"
			bootcmd=$bootcmd"setenv ipaddr "$ipaddr";\n"
		fi
		if [ "$gateway" != "" ]; then
			echo "MOS: found gateway=$gateway"
			bootcmd=$bootcmd"setenv gateway "$gateway";\n"
		fi
		if [ "$subnetmask" != "" ]; then
			echo "MOS: found subnetmask=$subnetmask"
			bootcmd=$bootcmd"setenv subnetmask "$subnetmask";\n"
		fi
		if [ "$system_parameters_1" != "" ]; then
			echo "MOS: found system_parameters_1=$system_parameters_1"
			bootcmd=$bootcmd"setenv system_parameters_1 "$system_parameters_1";\n"
		fi
		if [ "$system_parameters_2" != "" ]; then
			echo "MOS: found system_parameters_2=$system_parameters_2"
			bootcmd=$bootcmd"setenv system_parameters_2 "$system_parameters_2";\n"
		fi
		if [ "$system_parameters_3" != "" ]; then
			echo "MOS: found system_parameters_3=$system_parameters_3"
			bootcmd=$bootcmd"setenv system_parameters_3 "$system_parameters_3";\n"
		fi
		if [ "$system_parameters_4" != "" ]; then
			echo "MOS: found system_parameters_4=$system_parameters_4"
			bootcmd=$bootcmd"setenv system_parameters_4 "$system_parameters_4";\n"
		fi
		if [ "$Gbit" != "" ]; then
			echo "MOS: found Gbit=$Gbit"
			if [ $Gbit != "1" ]; then
				bootcmd=$bootcmd"unsetenv Gbit;\n"
			else
				bootcmd=$bootcmd"setenv Gbit;\n"
			fi
		fi
		if [ "$bootcmd" != "" ]; then
			bootcmd=$bootcmd" saveenv;factory -c \n\0\0"
			echo "MOS: command for boot shell"
			echo "MOS: command for boot shell" >> "$log"
			echo $bootcmd
			echo $bootcmd >> "$log"
			echo -en $bootcmd|dd bs=1 count=2048 seek=$bcs of=/dev/mtdblock0
			echo "MOS: do reboot"
			sync
			
			sleep 5
			for i in /tmp/usbmounts/* ; do umount $i ; done
			sleep 5
			
			reboot
		else 
			echo "MOS: no data for boot shell"
			echo "MOS: no data for boot shell" >> "$log"
		fi
	fi
else
	echo "MOS: no bootparams.txt"
	echo "MOS: no bootparams.txt" > "$log"
	sync
fi
		